#!/usr/bin/env python3
# 
# Cross Platform and Multi Architecture Advanced Binary Emulation Framework
#


lcd1602_table = """
-------------------------------------------------------------------------------------------------
|     |     |     | ### | ### |#### | #   |     |     |     |     |     |     |     |     |     |
|     |     |     |#   #|#   #|#   #|  #  |     |     |     |     |     | ####| ### | #  #|# ## |
|     |     |     |#  ##|    #|#   #|   # |#### |     |     |     |     | #  #|     |# # #|##  #|
|     |     |     |# # #| ## #|#### |     |#   #|     |     |     |#####|# # #| ### |#  # |#   #|
|     |     |     |##  #|# # #|#    |     |#### |     |     |     |     |   ##|     | ## #|#### |
|     |     |     |#   #|# # #|#    |     |#    |     |     |     |     |   # | ### |     |#    |
|     |     |     | ### | ### |#    |     |#    |     |     |     |     | ##  |    #|     |#    |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |  #  |  #  | ### | ### |     |     |     |     |     |#####|   # |     | # # |     |
|     |     |  #  | ##  |#   #|#   #|     |     |     |     |     |    #|###  |  #  | ### | ## #|
|     |     |  #  |  #  |#   #|#   #| ### | ## #|     |     |     |  # #|  #  | #   |    #|#  ##|
|     |     |  #  |  #  |#   #|#   #|    #|#  ##|     |     |     |  ## |#####|#    | ####|#   #|
|     |     |     |  #  |#####|# # #| ####| ####|     |     |###  |  #  |  #  |#   #|#   #| ####|
|     |     |     |  #  |#   #|#  # |#   #|    #|     |     |# #  |  #  |  #  |#####| ####|    #|
|     |     |  #  | ### |#   #| ## #| ####|    #|     |     |###  | #   | #   |    #|     |    #|
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     | # # | ### |#### |#### |#    |     |     |     |  ###|    #|     |     | ### | ### |
|     |     | # # |#   #|#   #|#   #|#    |     |     |     |  #  |   # |# # #|    #|#   #|#   #|
|     |     | # # |    #|#   #|#   #|#### |# ## |     |     |  #  |  #  |# # #|    #|#### |#####|
|     |     |     |   # |#### |#### |#   #|##  #|     |     |  #  | ##  |# # #| # # |#   #|#   #|
|     |     |     |  #  |#   #|# #  |#   #|#    |     |     |     |# #  |    #|  #  |#### |#   #|
|     |     |     | #   |#   #|#  # |#   #|#    |     |     |     |  #  |   # | # # |#    | ### |
|     |     |     |#####|#### |#   #|#### |#    |     |     |     |  #  |  #  |#    |#    |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |#    |     |
-------------------------------------------------------------------------------------------------
|     |     | # # |#####| ### | ####|     |     |     |     |     |  #  | ### |     |     |     |
|     |     | # # |   # |#   #|#    |     |     |     |     |     |#####|     |#####| ### |     |
|     |     |#####|  #  |#    |#    | ### | ### |     |     |     |#   #|#####| #   |#    | # ##|
|     |     | # # |   # |#    | ### |#    |#    |     |     |  #  |#   #|  #  |#####| ##  |# # #|
|     |     |#####|    #|#    |    #|#    | ### |     |     |  #  |    #|  #  | #   |#   #|## # |
|     |     | # # |#   #|#   #|    #|#   #|    #|     |     |  #  |   # |  #  | #   | ### |     |
|     |     | # # | ### | ### |#### | ### |#### |     |     |###  |  #  | #   |  ###|     |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |  #  |   # |###  |#####|    #| #   |     |     |     |     | #   | #   |     |     |
|     |     | ####|  ## |#  # |  #  |    #| #   |     |     |     |#####| #   | #   |#   #| ### |
|     |     |# #  | # # |#   #|  #  | ## #|###  |     |     |     |  #  | #   |#####|#   #|#   #|
|     |     | ### |#  # |#   #|  #  |#  ##| #   |     |     |     |  #  | ##  | #  #|#   #|#   #|
|     |     |  # #|#####|#   #|  #  |#   #| #   |     |     |#    |  #  | # # | # # |### #| # # |
|     |     |#### |   # |#  # |  #  |#   #| #  #|     |     | #   |  #  | #   | #   |#    |## ##|
|     |     |  #  |   # |###  |  #  | ####|  ## |     |     |  #  |#####| #   | #   |#    |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |##   |#####|#####|#   #|     |     |     |     |     |   # |  #  |     |     | # # |
|     |     |##  #|#    |#    |#   #|     |     |     |     |     |#####|  #  | ### | ####|#   #|
|     |     |   # |#### |#    |#   #| ### |#   #|     |     |     |   # |#####|   # |# #  |#   #|
|     |     |  #  |    #|#### |#   #|#   #|#   #|     |     | ##  |  ## |  #  |   # |#  # |#  ##|
|     |     | #   |    #|#    |#   #|#####|#   #|     |     | ##  | # # |  #  |   # | ### | ## #|
|     |     |#  ##|#   #|#    |#   #|#    |#  ##|     |     |     |#  # | #   |   # |     |     |
|     |     |   ##| ### |#####| ### | ### | ## #|     |     |     |   # |#    |#####|     |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     | ##  |  ## |#####|#   #|  ## |     |     |     |     | #   |     |     |     |#####|
|     |     |#  # | #   |#    |#   #| #  #|     |     |     |#####|#####| ### |#####|  ## | #   |
|     |     |# #  |#    |#    |#   #| #   |#   #|     |     |    #| #  #|     |    #| #  #|  #  |
|     |     | #   |#### |#### |#   #|###  |#   #|     |     |#####| #  #|     |#####|#   #| #   |
|     |     |# #  |#   #|#    |#   #| #   |#   #|     |     |    #| #  #|     |    #|#### |#####|
|     |     |#  # |#   #|#    | # # | #   | # # |     |     |   # | #  #|     |    #|#    |     |
|     |     | ## #| ### |#    |  #  | #   |  #  |     |     |  #  |#  # |#####|#####|#    |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     | ##  |#####| ### |#   #|     |     |     |     |     |  #  |     | ### |     |     |
|     |     |  #  |    #|#   #|#   #| ####|     |     |     |     |#####|#####|     | ### |#####|
|     |     | #   |   # |#    |#   #|#   #|#   #|     |     |#####|  #  |    #|#####|#   #| # # |
|     |     |     |  #  |# ###|#   #|#   #|#   #|     |     |    #|#####| # # |    #|#   #| # # |
|     |     |     | #   |#   #|# # #| ####|#   #|     |     |   # |  #  |  #  |    #| ####|#  ##|
|     |     |     | #   |#   #|# # #|    #|# # #|     |     |  #  |  #  | # # |   # |    #|     |
|     |     |     | #   | ### | ### | ### | # # |     |     | #   |  #  |#    |  #  |    #|     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     | ### |     |
-------------------------------------------------------------------------------------------------
|     |     |   # | ### |#   #|#   #|#    |     |     |     |     |     |  #  |#  # |     |#####|
|     |     |  #  |#   #|#   #|#   #|#    |     |     |     |     | ####|#####|#  # |  ###|#   #|
|     |     | #   |#   #|#   #| # # |# ## |#   #|     |     |   # | #  #|   # |#  # |  #  | # # |
|     |     | #   | ### |#####|  #  |##  #| # # |     |     |  #  |#   #|  #  |#  # |  #  |  #  |
|     |     | #   |#   #|#   #| # # |#   #|  #  |     |     | ##  |    #| ### |   # | #   |#   #|
|     |     |  #  |#   #|#   #|#   #|#   #| # # |     |     |# #  |   # |# # #|  #  |     |     |
|     |     |   # | ### |#   #|#   #|#   #|#   #|     |     |  #  | ##  |  #  | #   |     |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     | #   | ### | ### |#   #|  #  |     |     |     |     | #   |   # |     |     |     |
|     |     |  #  |#   #|  #  |#   #|     |     |     |     |     | ####|   # |  #  |## # |#   #|
|     |     |   # |#   #|  #  |#   #| ##  |#   #|     |     |  #  |#  # |   # |# #  |   # |#   #|
|     |     |   # | ####|  #  | # # |  #  |#   #|     |     |#####|   # |   # |# #  |     |#   #|
|     |     |   # |    #|  #  |  #  |  #  | ####|     |     |#   #|   # |   # |# # #|     | ####|
|     |     |  #  |   # |  #  |  #  |  #  |    #|     |     |    #|   # |  #  |# # #|     |    #|
|     |     | #   | ##  | ### |  #  | ### | ### |     |     |  ## |  #  | #   |# ## |     | ### |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |     |     |  ###|#####|   # |     |     |     |     |     |     |     |   # |    #|
|     |     |  #  | ##  |   # |    #|     |     |     |     |     |#####|  #  |#    |     |#### |
|     |     |# # #| ##  |   # |   # |  ## |#####|     |     |     |    #|   # |#    |  ## |  #  |
|     |     | ### |     |   # |  #  |   # |   # |     |     |#####|    #|#   #|#   #|   # |#####|
|     |     |# # #| ##  |   # | #   |   # |  #  |     |     |  #  |    #|#   #|#  # |   # |  #  |
|     |     |  #  | ##  |#  # |#    |#  # | #   |     |     |  #  |    #|#   #|# #  |   # |     |
|     |     |     |     | ##  |#####| ##  |#####|     |     |#####|#####|#   #|##   |#  # |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     | ##  |     |
-------------------------------------------------------------------------------------------------
|     |     |     |     |#   #| ### |#    |   # |     |     |     | # # |#    |     |# #  |     |
|     |     |  #  | ##  |#  # | #   |#    |  #  |     |     |     |#####|#    |#####| #   |#####|
|     |     |  #  | ##  |# #  | #   |#  # |  #  |     |     |   # | # # |#####|#   #|# #  | #   |
|     |     |#####|     |##   | #   |# #  | #   |     |     |#####| # # |#    |#   #|     | ####|
|     |     |  #  | ##  |# #  | #   |##   |  #  |     |     |  ## |   # |#    |#   #|     | #  #|
|     |     |  #  |  #  |#  # | #   |# #  |  #  |     |     | # # |  #  |#    |#   #|     |#   #|
|     |     |     | #   |#   #| ### |#  # |   # |     |     |#  # | #   | ####|#####|     |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |     |   # |#    |#   #| ##  |  #  |     |     |     |     |     |     |  #  |     |
|     |     |     |  #  |#    | # # |  #  |  #  |     |     |     |##   |#####|#####| ### |#####|
|     |     |     | #   |#    |#####|  #  |  #  |     |     | #   |    #|    #|#   #|# #  |# # #|
|     |     |     |#    |#    |  #  |  #  |  #  |     |     |#####|##  #|    #|#   #|# # #|#####|
|     |     | ##  | #   |#    |#####|  #  |  #  |     |     | #  #|    #|    #|    #| ### |#   #|
|     |     |  #  |  #  |#    |  #  |  #  |  #  |     |     | # # |   # |   # |   # |  #  |#   #|
|     |     | #   |   # |#####|  #  | ### |  #  |     |     | #   |###  | ##  |  #  |     |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |     |     |#   #| ### |     | #   |     |     |     |     |     |     | #   |     |
|     |     |     |     |## ##|   # |     |  #  |     |     |     |#####| #   |##   |###  |  #  |
|     |     |     |#####|# # #|   # |## # |  #  |     |     |     |    #|# #  |     | #   |#####|
|     |     |#####|     |# # #|   # |# # #|   # |     |     | ### |   # |   # |    #|###  |  #  |
|     |     |     |#####|#   #|   # |# # #|  #  |     |     |   # |  #  |    #|    #| #   |     |
|     |     |     |     |#   #|   # |#   #|  #  |     |     |   # | # # |    #|   # | ####|     |
|     |     |     |     |#   #| ### |#   #| #   |     |     |#####|#   #|     |###  |     |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |     | #   |#   #|  #  |     |     |     |     |     | #   |  #  |  #  | ### |     |
|     |     |     |  #  |#   #| # # |     |  #  |     |     |     |#####|#####|#  # |# ## |     |
|     |     |     |   # |##  #|#   #|# ## |   # |     |     |#### | #  #|  #  | #   |##  #|     |
|     |     |     |    #|# # #|     |##  #|#####|     |     |   # | # # |  #  |     |#   #|     |
|     |     |     |   # |#  ##|     |#   #|   # |     |     |#### | #   |# # #|     |#   #|     |
|     |     | ##  |  #  |#   #|     |#   #|  #  |     |     |   # | #   |# # #|     |     |     |
|     |     | ##  | #   |#   #|     |#   #|     |     |     |#### |  ###|  #  |     |     |     |
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |
-------------------------------------------------------------------------------------------------
|     |     |     | ### | ### |     |     |     |     |     |     |     |     |###  | # # |#####|
|     |     |    #|#   #|#   #|     |     |  #  |     |     |     |#   #|#####|# #  | ### |#####|
|     |     |   # |    #|#   #|     | ### | #   |     |     |     |#   #|    #|###  |#   #|#####|
|     |     |  #  |   # |#   #|     |#   #|#####|     |     |# # #| #  #|    #|     |#   #|#####|
|     |     | #   |  #  |#   #|     |#   #| #   |     |     |# # #|    #| # # |     | ### |#####|
|     |     |#    |     |#   #|     |#   #|  #  |     |     |    #|   # |  #  |     |     |#####|
|     |     |     |  #  | ### |#####| ### |     |     |     |  ## | ##  |   # |     |     |#####|
|     |     |     |     |     |     |     |     |     |     |     |     |     |     |     |#####|
-------------------------------------------------------------------------------------------------
"""